<?php 

require_once('../../../config.php');
require_once('../lib/function.php');

httpsrequired();
require_login();

global $USER, $CFG;
$loginUserid = $USER->id;

$courseID      = optional_param('courseid', 0, PARAM_INT);

if( !get_record('user', 'id', $loginUserid) ) {
      echo get_string('noStudentInformation9', 'reportmodule');
      exit;
} else {
      $courseUserArray = array();
      $userPassArray = array();
      if($courseID) {
            if ( !get_record('reportmodule', 'courseid', $courseID) ) {
                  echo get_string('courseNoSetup9', 'reportmodule');
                  exit;
            }
            if( !get_course_students($courseID) ) {
                  echo get_string('theCourseNowNoStudent9', 'reportmodule');
                  exit;
            } else {
                  if ( $course = get_record('course', 'id', $courseID) ) {
                        $userPass = true;
                        $courseUserLogData = produceUserCourseLog($loginUserid, $courseID);
                        $courseUserArray[$courseID] = produceCourseUserArray($loginUserid, $courseID, $courseUserLogData, $userPass);
                        $userPassArray[$courseID] = $userPass;
                  } else {
                        echo get_string('pleaseSelectRightCourseName9', 'reportmodule');
                        exit;
                  }  
            }
      } else {
            $courses = reportmycoursesdata($loginUserid);
            foreach( $courses as $theCourseID => $theCourseName ) {
                  if( get_course_students($theCourseID) ) {
                        //!the course no student
                        if ( get_record('reportmodule', 'courseid', $theCourseID) ) {
                              //!the course don't setup stardard
                              if ( $courseActionItem = getCourseActionItem($theCourseID) ) {
                                    //!the course no action
                                    $userPass = true;
                                    $timeDifferent = getTimeDifferent($dateform);
                                    $courseUserLogData = produceUserCourseLog($loginUserid, $theCourseID);
                                    $courseUserArray[$theCourseID] = produceCourseUserArray($loginUserid, $theCourseID, $courseUserLogData, $userPass);
                                    $userPassArray[$theCourseID] = $userPass;
                              }
                        }
                  }
            }
            if(!$courseUserArray) {
                  echo get_string('allCcourseNoSetup9', 'reportmodule');
                  exit;
            }
      }
}

print_heading(get_string('studentStudySearchResult9', 'reportmodule'));
            
/*   course data inforamtion table    */
$user = get_record('user', 'id', $loginUserid);
echo '<p>'.get_string('studentName9', 'reportmodule').$user->firstname.$user->lastname.'</p>';
echo '<p>'.get_string('studentBrief9', 'reportmodule').$user->description.'</p>';
echo '<p>'.get_string('email9', 'reportmodule').$user->email.'</p>';
foreach($courseUserArray as $theCourseID => $courseUserData) {
      $course = get_record('course', 'id', $theCourseID); //for one row
      $category = get_record('course_categories', 'id', $course->category);
      echo '<table border="1" width="600">';
      echo '<tr>';
            echo '<td colspan="5">'.get_string('courseCategory9', 'reportmodule').format_string($category->name).'</td>';
      echo '</tr>';
      echo '<tr>';
            echo '<td colspan="5">'.get_string('courseName9', 'reportmodule').format_string($course->fullname).'</td>';
      echo '</tr>';
      echo '<tr>';
            echo '<td>'.get_string('actioninformation9', 'reportmodule').'</td>';
            echo '<td>'.get_string('actionCategory9', 'reportmodule').'</td>';
            echo '<td>'.get_string('actionTime9', 'reportmodule').'</td>';
            echo '<td>'.get_string('actionScore9', 'reportmodule').'</td>';
            echo '<td>'.get_string('passStandard9', 'reportmodule').'</td>';
      echo '</tr>';
      foreach ($courseUserData as $courseUserActionID => $courseUserActionContent) {

      if ( getCourseActionModName($courseUserActionID) ) {
            $actionModName = getCourseActionModName($courseUserActionID);
            $actionModCategory = getActionItemModuleName($courseUserActionID);
      } else {
            $actionModName = get_string('courseTime9', 'reportmodule');
            $actionModCategory = get_string('course9', 'reportmodule');
      }
      echo '<tr>';
            echo '<td>'.$actionModName.'</td>';
            echo '<td>'.$actionModCategory.'</td>';
            echo '<td>'.( ($courseUserActionContent['timeEnable'])
                        ? $courseUserActionContent['time']
                        :'不採計' )
                  .'</td>';
            echo '<td>'.( ($courseUserActionContent['scoreEnable'])
                        ? $courseUserActionContent['score']
                        :'不採計' )
                  .'</td>';
            echo '<td>'.(($courseUserActionContent['scorePass'] AND
                              $courseUserActionContent['timePass'])?
                         get_string('pass9', 'reportmodule'):
                         '<span class="obviousword1">'.
                         get_string('unpass9', 'reportmodule')).'</span></td>';
      echo '</tr>';
      
      }
      echo '<tr>';
            echo '<td colspan="5" align="right">'.get_string('passif9', 'reportmodule')
            .(($userPassArray[$theCourseID])?
              get_string('pass9', 'reportmodule'):
              '<span class="obviousword1">'.
              get_string('unpass9', 'reportmodule')).'</span></td>';
      echo '</tr>';
      echo '</table>';
      echo '<br />';
}

//print_footer();

?>